﻿-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- --
-- Script:  Mini_GPS
-- Version: 1.2
-- Build:   2015-02-07
-- By:      oe3gsu@x-plane.at
-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- --
-- Description:
-- 
--                        see Manual
-- 
-- 
-- 
-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- --

-- USER editable values -------------------------------------------------------------------------------
--                                                                                                   --
--                 there are no, i repeat: NO user-editable values in this script !!!                --
--                                 PLEASE READ THE MANUAL                                            --
--                                                                                                   --
---------- DONT edit anything below this line !!! -----------------------------------------------------

-- STARTUP --------------------------------------------------------------------------

require("graphics")

DataRef("GPS_xp_LAT", "sim/flightmodel/position/latitude", "readonly")
DataRef("GPS_xp_LON", "sim/flightmodel/position/longitude", "readonly")
DataRef("GPS_xp_true_psi", "sim/flightmodel/position/mag_psi", "readonly")
DataRef("GPS_xp_autopilot_psi", "sim/cockpit/autopilot/heading_mag", "writable")
DataRef("GPS_xp_groundspeed", "sim/flightmodel/position/groundspeed", "readonly")

local GPS_header = "   Mini.GPS by oe3gsu 1.2"
local GPS_debug = false
local GPS_show = true
local GPS_mode = "route"      -- "manu|auto|route" manu: manual entered values, fly there   auto: reading file successfull, follow route     route: switch to next WP on reach  
local GPS_enter_mode = 0     -- 0 | 1 | 2  "0" run-mode  "1"  enter LAT    "2"  enter LON
GPS_SW_MODE = false
local GPS_AP_feed = false
local window_move = false
local X_offset = 0      -- Differenz zu Mitte X
local Y_offset = 0      -- Differenz zu Mitte X
local X_Mouse0 = 0      -- Maus Position bei Klick im Kreuz X
local Y_Mouse0 = 0      -- Maus Position bei Klick im Kreuz Y
local window_x = 0
local window_y = 0

local GPS_LAT_val = GPS_xp_LAT -- 48.446     -- Value LAT
local GPS_LAT_disp = string.format("%2.4f", GPS_LAT_val) -- "48.446"  -- Display LAT
local GPS_LON_val = GPS_xp_LON --017.629    -- Value LON
local GPS_LON_disp = string.format("%03.4f", GPS_LON_val) -- "017.629" -- Display LON

local GPS_Name_WP = ""

local GPS_head = 0
local GPS_dist = 0

local GPS_fpl_count = 0
local GPS_fpl_lines = {}
local GPS_fpl_maxlines = 0
local GPS_fpl_found = false

function GPS_load_settings() -------------------------------------------------------- LOAD SETTINGS
  
    file = io.open(SCRIPT_DIRECTORY .. "MiniGPS.fpl", "r")
    if file ~= nil then 
      GPS_fpl_found = true
      GPS_fpl_lines[0] = (GPS_LAT_disp .. " " .. GPS_LON_disp .. " Start-Position ") -- set WP0 with actual position
      GPS_mode = "route"
      local j = 1
      for i=1, 99 do
        rd = file:read("*line")
        if rd ~= "" then                                      -- check if line is empty
          GPS_fpl_lines[j] = rd
          if GPS_fpl_lines[j] == nil then 
            file:close()
            break 
          else
            if string.sub(GPS_fpl_lines[j], 1, 2) ~= "--" then  -- check if remark
              GPS_fpl_maxlines = j
              j = j + 1                                         -- next waypoint
            end
            i = i + 1                                           -- next line read
          end
        end
      end
    else
      GPS_mode = "manu"
    end
  
end -----------------------------------------------------------

GPS_load_settings()

function GPS_show_display() --------------------------------------------------------SHOW Display
if GPS_show == true then
  XPLMSetGraphicsState(0,0,0,1,1,0,0)
  if window_move == true then
    X_offset = MOUSE_X - X_Mouse0
    Y_offset = MOUSE_Y - Y_Mouse0
  end
  window_x = 10 + X_offset -- (SCREEN_WIDTH / 2) - 50
  window_y = SCREEN_HIGHT - 120 + Y_offset
  graphics.set_color(0.5, 0.5, 0.5, 1)                                                                -- window
  graphics.draw_rectangle(window_x, window_y, window_x+200, window_y+95)
  graphics.set_color(0.7, 0.7, 0.7, 1)                                                                -- Header
  graphics.draw_rectangle(window_x, window_y+80, window_x+200, window_y+95)
  graphics.set_color(1.0, 0.0, 0.0, 1)                                                                -- Move-Cross
  graphics.draw_rectangle(window_x, window_y+80, window_x+15, window_y+95)
  
  graphics.set_color(1.0, 1.0, 1.0, 1)
  graphics.draw_line(window_x+3, window_y+88, window_x+13, window_y+88) -- Cross waagrecht
  graphics.draw_line(window_x+8, window_y+92, window_x+8, window_y+82) -- Cross senkrecht
  
  graphics.set_color(0.2, 0.2, 0.2, 1)                                                                -- Close Sign
  graphics.draw_rectangle(window_x+185, window_y+80, window_x+199, window_y+95)
  graphics.set_color(1.0, 1.0, 1.0, 1)
  graphics.draw_line(window_x+188, window_y+88, window_x+196, window_y+88) -- Cross waagrecht
  
  draw_string_Helvetica_12(window_x+25, window_y+82, GPS_header)
  graphics.draw_line(window_x+200, window_y, window_x+200, window_y+95) -- rechts
  graphics.draw_line(window_x+200, window_y+95, window_x, window_y+95) -- oben
  graphics.set_color(0.0, 0.0, 0.0, 1)
  graphics.draw_line(window_x, window_y, window_x, window_y+95) -- links
  graphics.draw_line(window_x+200, window_y, window_x, window_y) -- unten
  
  graphics.set_color(1.0, 1.0, 1.0, 1)
  draw_string_Helvetica_12(window_x+20, window_y+45, "Lat")
  draw_string_Helvetica_12(window_x+100, window_y+45, "Lon")
  draw_string_Helvetica_12(window_x+5, window_y+25, "Head.")
  draw_string_Helvetica_12(window_x+100, window_y+25, "Dist.")
  
  graphics.draw_rectangle(window_x+40, window_y+43, window_x+95, window_y+55) -- LAT field
  graphics.draw_rectangle(window_x+125, window_y+43, window_x+180, window_y+55) -- LON field
  
  if GPS_AP_feed == true then graphics.set_color(1.0, 1.0, 0.2, 1) else graphics.set_color(1.0, 1.0, 1.0, 1) end
  graphics.draw_rectangle(window_x+5, window_y+5, window_x+195, window_y+20) -- CDI field
  graphics.set_color(0.0, 0.0, 0.0, 1)
  graphics.draw_line(window_x+10, window_y+5, window_x+10, window_y+20)      -- left
  graphics.draw_line(window_x+45, window_y+5, window_x+45, window_y+12)      -- semi left
  graphics.draw_line(window_x+100, window_y+5, window_x+100, window_y+20)    -- center
  graphics.draw_line(window_x+145, window_y+5, window_x+145, window_y+12)    -- semi-right
  graphics.draw_line(window_x+190, window_y+5, window_x+190, window_y+20)    -- right
  
  if GPS_mode == "auto" or GPS_mode == "route" then
    graphics.set_color(1.0, 1.0, 1.0, 1)
    graphics.draw_rectangle(window_x+3, window_y+43, window_x+18, window_y+55) -- Step-Counter field
    graphics.set_color(0.7, 0.7, 0.7, 1)
    graphics.draw_rectangle(window_x+185, window_y+47, window_x+195, window_y+57) -- UP field
    graphics.draw_rectangle(window_x+185, window_y+36, window_x+195, window_y+46) -- DN field
    graphics.set_color(0.0, 0.0, 0.0, 1)
    draw_string_Helvetica_12(window_x+187, window_y+47, "<")
    draw_string_Helvetica_12(window_x+187, window_y+36, ">")
    graphics.set_color(1.0, 1.0, 1.0, 1)
    draw_string_Helvetica_12(window_x+2, window_y+63, "Wayp.")
    if GPS_mode == "route" then
      graphics.set_color(1.0, 1.0, 0.0, 1)
    else
      graphics.set_color(1.0, 1.0, 1.0, 1)
    end
      graphics.draw_rectangle(window_x+40, window_y+61, window_x+180, window_y+73) -- Name field
  else
    graphics.set_color(0.7, 0.7, 0.7, 1)
    graphics.draw_rectangle(window_x+3, window_y+43, window_x+18, window_y+55) -- Step-Counter field
   
  end
  
  if GPS_mode == "auto" or GPS_mode == "route" then ---------------------------------------------------------------- Ausgabe
    graphics.set_color(0.0, 0.0, 0.0, 1)
    draw_string_Helvetica_12(window_x+3, window_y+44, string.format("%02.0f", GPS_fpl_count))
    draw_string_Helvetica_12(window_x+42, window_y+63, GPS_Name_WP)
  end
  if GPS_enter_mode == 1 then graphics.set_color(1.0, 0.0, 0.0, 1) else graphics.set_color(0.0, 0.0, 0.0, 1) end
  draw_string_Helvetica_12(window_x+40, window_y+45, GPS_LAT_disp)                -- LAT
  if GPS_enter_mode == 2 then graphics.set_color(1.0, 0.0, 0.0, 1) else graphics.set_color(0.0, 0.0, 0.0, 1) end
  draw_string_Helvetica_12(window_x+125, window_y+45, GPS_LON_disp)               -- LON
  graphics.set_color(1.0, 1.0, 0.0, 1)
  draw_string_Helvetica_12(window_x+40, window_y+25, string.format("%3.0f", GPS_head) .. " deg")                -- TEST - STRING  DEG
  draw_string_Helvetica_12(window_x+130, window_y+25, string.format("%4.2f", GPS_dist) .. " nm")               -- TEST - STRING   DIST
  --            SOLL         IST 
  local devi = GPS_head - GPS_xp_true_psi
  if devi > 180 then devi = devi - 360 end
  if devi < -180 then devi = devi + 360 end
  
  if devi > 90 then devi = 90 end
  if devi < -90 then devi = -90 end
  graphics.set_color(0.0, 0.0, 1.0, 1)
  graphics.draw_rectangle(window_x+97 + devi, window_y+5, window_x+103 + devi, window_y+20) -- CDI Indicator
  
  if GPS_debug == true then
    draw_string_Helvetica_12(window_x+240, window_y+65, "|" .. GPS_LAT_disp .. "|" .. find1)
    draw_string_Helvetica_12(window_x+240, window_y+45, "|" .. GPS_LON_disp .. "|" .. find2)
    if find3 ~= nil then 
      draw_string_Helvetica_12(window_x+240, window_y+25, "|" .. GPS_Name_WP .. "|" .. find3)
    else
       draw_string_Helvetica_12(window_x+240, window_y+25, "|" .. GPS_Name_WP .. "|")
   end
  
  end 
else
  graphics.set_color(0.5, 0.5, 0.5, 1)                                                                -- window
  graphics.draw_rectangle(0, 0, 55, 15)
  graphics.set_color(1.0, 1.0, 1.0, 1)
  draw_string_Helvetica_12(1, 1, "MiniGPS")
  
end
end -- function --------------------------------------------------------------------------

do_every_draw("GPS_show_display()")

function GPS_main() ----------------------------------------------------------------- MAIN
-- GPS_xp_LAT  GPS_xp_LON  GPS_LAT_val  GPS_LON_val
-- breite A    Länge A     Breite B     Länge B
  local K = math.pi / 180 -------------------------------------- Calculation heading and distance
  local lat1 = GPS_xp_LAT * K
  local lat2 = GPS_LAT_val * K
  local lon1 = GPS_xp_LON * K
  local lon2 = GPS_LON_val * K
  local M = math.acos(math.sin(lat1) * math.sin(lat2) + math.cos(lat1) * math.cos(lat2) * math.cos(lon1 - lon2))
  GPS_dist = ((180*60)/math.pi) * M 
  local N = 0
  if math.sin(lon2 - lon1) > 0 then
    N = math.acos((math.sin(lat2)-math.sin(lat1)*math.cos(M))/(math.sin(M)*math.cos(lat1)))
  else
    N = 2*math.pi-math.acos((math.sin(lat2)-math.sin(lat1)*math.cos(M))/(math.sin(M)*math.cos(lat1)))    
  end 
  GPS_head = (180/math.pi) * N --------------------------------- Calculation END
  
  if GPS_AP_feed == true then GPS_xp_autopilot_psi = GPS_head end --  Set AP-Course
  
  --GPS_xp_groundspeed
  if GPS_dist < (GPS_xp_groundspeed/51.4444) and GPS_mode == "route" then
    if GPS_fpl_count < GPS_fpl_maxlines then 
      GPS_fpl_count = GPS_fpl_count + 1 
      GPS_update_LATLON()
    else
      GPS_AP_feed = false
    end
    -- if GPS_fpl_count >= GPS_fpl_maxlines then GPS_fpl_count = GPS_fpl_maxlines end
  end
end

do_often("GPS_main()")

function GPS_update_LATLON()
  local find1 = 0
  local find2 = 0
  local find3 = 0
  local strg_rest = ""
  find1 = string.find(GPS_fpl_lines[GPS_fpl_count], " ")               -- Position erstes Blank nach LAT
  GPS_LAT_disp = string.sub(GPS_fpl_lines[GPS_fpl_count], 1, find1)    -- LAT-String aus GESAMT von 1 bis 1.Blank
  strg_rest = string.sub(GPS_fpl_lines[GPS_fpl_count], find1+1)          -- Rest_String = GESAMT von 1.Blank bis Ende
  find2 = string.find(strg_rest, " ")                                  -- Position zweites Blank nach LON
  GPS_LON_disp = string.sub(strg_rest, 1, find2)
  strg_rest = string.sub(strg_rest, find2+1)                             -- Rest_String = GESAMT von 2. Blank bis Ende
  find3 = string.find(strg_rest, " ")                                 -- Position "--" REMARK nach LON
  if find3 == nil then find3 = string.find(strg_rest, "-") end
  if find3 == nil then find3 = string.len(strg_rest) + 1 end
  if find3 ~= nil then
    GPS_Name_WP = string.sub(strg_rest, 1, find3-1)
  else
    GPS_Name_WP = ""
  end
  GPS_LAT_disp = string.format("%2.4f", GPS_LAT_disp)
  GPS_LON_disp = string.format("%2.4f", GPS_LON_disp)
  GPS_LAT_val = tonumber(GPS_LAT_disp)
  GPS_LON_val = tonumber(GPS_LON_disp)
  GPS_main()
end

function GPS_mouse_click_events() --------------------------------------------------------------------------------- Mouse Click -----------
--window_x, window_y+80, window_x+15, window_y+95  
  if MOUSE_STATUS == "down" and MOUSE_X > window_x and MOUSE_X < window_x+15 and MOUSE_Y > window_y+80 and MOUSE_Y < window_y+95 then ----------Click in MOVE
    if window_move == false then
      X_Mouse0 = MOUSE_X - X_offset
      Y_Mouse0 = MOUSE_Y- Y_offset
      window_move = true
    else
      window_move = false
    end
    RESUME_MOUSE_CLICK = true
  elseif MOUSE_STATUS == "down" and MOUSE_X > window_x+40 and MOUSE_X < window_x+95 and MOUSE_Y > window_y+43 and MOUSE_Y < window_y+55 then --------------Click in LAT-Field
    GPS_enter_mode = 1
    GPS_mode = "manu"
    GPS_LAT_disp = ""
    RESUME_MOUSE_CLICK = true
  elseif MOUSE_STATUS == "down" and MOUSE_X > window_x+125 and MOUSE_X < window_x+180 and MOUSE_Y > window_y+43 and MOUSE_Y < window_y+55 then --------------Click in LON-Field
    GPS_enter_mode = 2
    GPS_LON_disp = ""
    GPS_mode = "manu"
    RESUME_MOUSE_CLICK = true
  elseif MOUSE_STATUS == "down" and MOUSE_X > window_x+5 and MOUSE_X < window_x+195 and MOUSE_Y > window_y+5 and MOUSE_Y < window_y+20 then --------------Click in CDI-Field
    if GPS_AP_feed == true then GPS_AP_feed = false else GPS_AP_feed = true end
    RESUME_MOUSE_CLICK = true
  elseif MOUSE_STATUS == "down" and MOUSE_X > window_x+3 and MOUSE_X < window_x+18 and MOUSE_Y > window_y+43 and MOUSE_Y < window_y+55 and GPS_fpl_found == true then --------------Click in Counter-Field
    if GPS_mode == "auto" then GPS_mode = "manu" else GPS_mode = "auto" end
    RESUME_MOUSE_CLICK = true
  -- window_x+185, window_y+47, window_x+195, window_y+57) -- UP field
  elseif MOUSE_STATUS == "down" and MOUSE_X > window_x+185 and MOUSE_X < window_x+195 and MOUSE_Y > window_y+47 and MOUSE_Y < window_y+57 and GPS_mode == "auto" then --------------Click in UP-Field
    GPS_fpl_count = GPS_fpl_count - 1
    if GPS_fpl_count < 0 then GPS_fpl_count = 0 end
    GPS_update_LATLON()
    RESUME_MOUSE_CLICK = true
  elseif MOUSE_STATUS == "down" and MOUSE_X > window_x+185 and MOUSE_X < window_x+195 and MOUSE_Y > window_y+36 and MOUSE_Y < window_y+46 and GPS_mode == "auto" then --------------Click in DN-Field
    GPS_fpl_count = GPS_fpl_count + 1
    if GPS_fpl_count > GPS_fpl_maxlines then GPS_fpl_count = GPS_fpl_maxlines end
    GPS_update_LATLON()
    RESUME_MOUSE_CLICK = true
  elseif MOUSE_STATUS == "down" and MOUSE_X > window_x+40 and MOUSE_X < window_x+180 and MOUSE_Y > window_y+61 and MOUSE_Y < window_y+73 and (GPS_mode == "auto" or GPS_mode == "route") then --------------Click in Name-Field
    if GPS_mode == "auto" then GPS_mode = "route" else GPS_mode = "auto" end
    RESUME_MOUSE_CLICK = true
  --window_x+185, window_y+80, window_x+199, window_y+95
  elseif MOUSE_STATUS == "down" and MOUSE_X > window_x+185 and MOUSE_X < window_x+199 and MOUSE_Y > window_y+80 and MOUSE_Y < window_y+95 and GPS_show == true then --------------Click in Close-Field
    GPS_show = false
    RESUME_MOUSE_CLICK = true
  --0, 0, 55, 15
  elseif MOUSE_STATUS == "down" and MOUSE_X > 0 and MOUSE_X < 55 and MOUSE_Y > 0 and MOUSE_Y < 15 and GPS_show == false then --------------Click in Close-Field
    GPS_show = true
    RESUME_MOUSE_CLICK = true
  end
  
end

do_on_mouse_click("GPS_mouse_click_events()")

function GPS_keystroke()
  if GPS_enter_mode == 0 then return end
  if KEY_ACTION == "released" then
  GPS_VKEY = VKEY
    if CKEY >= "0" and CKEY <= "9" or CKEY == "-" or CKEY == "," or CKEY == "." or CKEY == "+" or VKEY == 27 then
      local KEY = CKEY
      if KEY == "," then KEY = "." end
      if GPS_enter_mode == 1 then
        if CKEY == "+" then 
          GPS_LAT_val = tonumber(GPS_LAT_disp)
          if GPS_LAT_val > 90 or GPS_LAT_val < -90 then
            GPS_LAT_disp = " ERROR"
          else
            GPS_LAT_disp = string.format("%2.4f", GPS_LAT_disp)
            GPS_enter_mode = 0
          end
        elseif VKEY == 27 then 
          GPS_LAT_disp = ""
        else
          GPS_LAT_disp = GPS_LAT_disp .. KEY
        end
      end
      if GPS_enter_mode == 2 then
        if CKEY == "+" then 
          GPS_LON_val = tonumber(GPS_LON_disp)
          if GPS_LON_val > 180 or GPS_LON_val < -180 then
            GPS_LON_disp = " ERROR"
          else
            GPS_LON_disp = string.format("%03.4f", GPS_LON_disp)
            GPS_enter_mode = 0
          end
        elseif VKEY == 27 then 
          GPS_LON_disp = ""
        else
          GPS_LON_disp = GPS_LON_disp .. KEY
        end
      end
      RESUME_KEY = true
    end
  end
end
do_on_keystroke("GPS_keystroke()")

function GPS_switch_mode() --------------------------------------------------------------SWITCH MODE
    if GPS_SW_MODE == true then
      if GPS_AP_feed == true then 
        GPS_AP_feed = false 
      else 
        GPS_AP_feed = true 
      end
      GPS_SW_MODE = false
    end
end

do_every_draw("GPS_switch_mode()")

create_command("FlyWithLua/MiniGPS/switch_AP-Feed", "Switch AP-Feed", "GPS_SW_MODE = true", "", "")


